<style global>
  @import "../node_modules/jsoneditor/dist/jsoneditor.min.css";
</style>

<script>
	import {onMount, beforeUpdate , afterUpdate, createEventDispatcher} from 'svelte';
	let container, editor,updatedJson,module,JSONEditor;
	export let json = {"key": "This is a default json"};
	let dispatch = createEventDispatcher();
	$: json = editor? (editor.set(json)) : json

	let options = {
		mode: 'tree',
		modes: ['code', 'form', 'text', 'tree', 'view'],	
		indentation: 4,
		escapeUnicode: true,

		onChange: function () {
			dispatch('magicalclick' , {data : editor.get()});
			},

		onModeChange: function (mode) {
			let treeMode = document.getElementById('treeModeSelection');
			treeMode.style.display = textMode.style.display = 'none';
			if (mode === 'code' || mode === 'text') {
				textMode.style.display = 'inline';
			} else {
				treeMode.style.display = 'inline';
			}
			},
			
		onTextSelectionChange: function(start, end, text) {
			let rangeEl = document.getElementById('textRange');
			rangeEl.innerHTML = 'start: ' + JSON.stringify(start) + ', end: ' + JSON.stringify(end);
			let textEl = document.getElementById('selectedText');
			textEl.innerHTML = text;
			},

		onSelectionChange: function(start, end) {      
			let nodesEl = document.getElementById('selectedNodes');
			nodesEl.innerHTML = '';
			if (start) {
				nodesEl.innerHTML = ('start: '  + JSON.stringify(start));
				if (end) {
				nodesEl.innerHTML += ('<br/>end: '  + JSON.stringify(end));
				}
				console.log(nodesEl.innerHTML);
			}
		}
		};
	onMount( async() => {	
		module = await import ('jsoneditor');
		JSONEditor = module.default;
        container = document.getElementById("jsoneditor");
        editor = new JSONEditor(container, options);
        editor.set(json);
	}); 

</script>

<main>
<div id="jsoneditor" style="width: 500px; height: 500px;"></div>
	<body>
	</body>
</main>